Display the group structure with a single generated column in the grid.
import {
ClientSideRowModelModule,
GridApi,
GridOptions,
ModuleRegistry,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([ClientSideRowModelModule, RowGroupingModule]);
let gridApi: GridApi<IOlympicData>;
const gridOptions: GridOptions<IOlympicData> = {
columnDefs: [
{ field: "country", rowGroup: true, hide: true },
{ field: "year", rowGroup: true, hide: true },
{ field: "athlete" },
{ field: "sport" },
{ field: "total" },
],
defaultColDef: {
flex: 1,
minWidth: 100,
},
autoGroupColumnDef: {
minWidth: 200,
},
// optional as 'singleColumn' is the default group display type
groupDisplayType: "singleColumn",
groupDefaultExpanded: 1,
};
const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((response) => response.json())
.then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
<div id="myGrid" style="height: 100%"></div>
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Enabling a Single Group Column Copy Link
The example above demonstrates that both country and year are grouped. Only a single group column is used to display the group value cells.
The Single Group Column is enabled by default, but it can be set explicitly by setting the groupDisplayType grid option to "singleColumn" as shown below:
const gridOptions = {
groupDisplayType: 'singleColumn',
// other grid options ...
} Configuration Copy Link
The Single Group Column is added to the grid when row grouping is present, and can be configured via the autoGroupColumnDef grid option to define Column Options.
import {
ClientSideRowModelModule,
GridApi,
GridOptions,
ModuleRegistry,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([ClientSideRowModelModule, RowGroupingModule]);
let gridApi: GridApi<IOlympicData>;
const gridOptions: GridOptions<IOlympicData> = {
columnDefs: [
{ field: "country", rowGroup: true, hide: true },
{ field: "year", rowGroup: true, hide: true },
{ field: "sport" },
{ field: "total" },
],
defaultColDef: {
flex: 1,
minWidth: 100,
},
autoGroupColumnDef: {
headerName: "My Group",
field: "athlete",
minWidth: 220,
cellRendererParams: {
suppressCount: true,
},
},
// optional as 'singleColumn' is the default group display type
groupDisplayType: "singleColumn",
groupDefaultExpanded: -1,
};
const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((response) => response.json())
.then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
<div id="myGrid" style="height: 100%"></div>
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} The example above uses the configuration demonstrated below to change the columns header name, apply a minimum width, and display athlete values in the leaf level rows. It also Configures the Group Cell Component using the cellRendererParams option to remove the count from each row group.
const gridOptions = {
autoGroupColumnDef: {
headerName: 'My Group',
field: 'athlete',
minWidth: 220,
cellRendererParams: {
suppressCount: true,
}
},
// other grid options ...
} Cell Component Copy Link
The group column uses the agGroupCellRenderer component to display the group information, as well as the chevron control for expanding and collapsing rows. The renderer also embeds the grouped columns renderer and displays this inside of the group cell.
This can be configured with several Group Renderer Properties using the autoGroupColumnDef property cellRendererParams. The example below removes the row count and also Configures Row Selection to enable checkboxes for row selection.
import {
ClientSideRowModelModule,
GridApi,
GridOptions,
ModuleRegistry,
RowSelectionModule,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
import { CustomMedalCellRenderer } from "./customMedalCellRenderer";
import { IOlympicData } from "./interfaces";
// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([
RowSelectionModule,
ClientSideRowModelModule,
RowGroupingModule,
]);
let gridApi: GridApi<IOlympicData>;
const gridOptions: GridOptions<IOlympicData> = {
columnDefs: [
{ field: "total", rowGroup: true, cellRenderer: CustomMedalCellRenderer },
{ field: "year" },
{ field: "athlete" },
{ field: "sport" },
],
defaultColDef: {
flex: 1,
minWidth: 100,
},
autoGroupColumnDef: {
headerName: "Gold Medals",
minWidth: 240,
cellRendererParams: {
suppressCount: true,
},
},
// optional as 'singleColumn' is the default group display type
groupDisplayType: "singleColumn",
rowSelection: {
mode: "singleRow",
checkboxLocation: "autoGroupColumn",
},
};
var gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((response) => response.json())
.then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
.imgSpan {
display: flex;
height: 40px;
width: 100%;
align-items: center;
}
.medalIcon {
display: block;
width: 15px;
height: auto;
max-height: 50%;
}
import { ICellRendererParams } from 'ag-grid-community';
export function CustomMedalCellRenderer(params: ICellRendererParams) {
const priceSpan = document.createElement('span');
priceSpan.setAttribute('class', 'imgSpan');
for (let i = 0; i < params.value ?? 0; i++) {
const priceElement = document.createElement('img');
priceElement.src = `https://www.ag-grid.com/example-assets/gold-star.png`;
priceElement.setAttribute('class', 'medalIcon');
priceSpan.appendChild(priceElement);
}
return priceSpan;
}
<div id="myGrid" style="height: 100%"></div>
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} The example above demonstrates the following configuration:
const gridOptions = {
columnDefs: [
{ field: 'total', rowGroup: true, cellRenderer: CustomMedalCellRenderer },
// ... other column definitions
],
autoGroupColumnDef: {
cellRendererParams: {
suppressCount: true,
}
},
rowSelection: {
mode: 'singleRow',
checkboxLocation: 'autoGroupColumn',
},
// other grid options ...
} Configurable Options Copy Link
Set to true to not include any padding (indentation) in the child rows. |
Set to true to suppress expand on double click. |
Set to true to suppress expand on â” Enter |
The value getter for the total row text. Can be a function or expression. |
If true, count is not displayed beside the name. |
The renderer to use for inside the cell (after grouping functions are added) |
Additional params to customise to the innerRenderer. |
Callback to enable different innerRenderers to be used based of value of params. |
Checkbox Selection Copy Link
The agGroupCellRenderer can be configured to show checkboxes for row selection. Setting the Row Selection checkboxLocation property to 'autoGroupColumn' hides the Checkbox Column instead using the group cell renderer to display checkboxes.
Setting groupSelects to 'descendants' causes selecting a group row to also select all of its children.
import {
ClientSideRowModelModule,
GridApi,
GridOptions,
ModuleRegistry,
RowSelectionModule,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([
RowSelectionModule,
ClientSideRowModelModule,
RowGroupingModule,
]);
let gridApi: GridApi<IOlympicData>;
const gridOptions: GridOptions<IOlympicData> = {
columnDefs: [
{ field: "country", rowGroup: true },
{ field: "athlete" },
{ field: "year" },
{ field: "sport" },
],
defaultColDef: {
flex: 1,
minWidth: 100,
},
autoGroupColumnDef: {
minWidth: 220,
},
rowSelection: {
mode: "multiRow",
groupSelects: "descendants",
selectAll: "all",
checkboxLocation: "autoGroupColumn",
},
};
var gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((response) => response.json())
.then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
<div id="myGrid" style="height: 100%"></div>
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} The example above demonstrates the following configuration:
const gridOptions = {
rowSelection: {
mode: 'multiRow',
groupSelects: 'descendants',
selectAll: 'all',
checkboxLocation: 'autoGroupColumn',
},
// other grid options ...
} Custom Inner Renderer Copy Link
When using the group cell renderer, the agGroupCellRenderer component will inherit the grouped columns renderer and display this inside of the group cell, adjacent to any configured checkboxes, cell count, and the expand/collapse chevron control.
This inner renderer can be overridden with a Custom Cell Component by setting the innerRenderer and innerRendererParams properties on the cellRendererParams configuration.
import {
ClientSideRowModelModule,
GridApi,
GridOptions,
ModuleRegistry,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
import { CustomMedalCellRenderer } from "./customMedalCellRenderer";
import { IOlympicData } from "./interfaces";
// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([ClientSideRowModelModule, RowGroupingModule]);
let gridApi: GridApi<IOlympicData>;
const gridOptions: GridOptions<IOlympicData> = {
columnDefs: [
{ field: "total", rowGroup: true },
{ field: "country" },
{ field: "year" },
{ field: "athlete" },
{ field: "sport" },
],
defaultColDef: {
flex: 1,
minWidth: 100,
},
autoGroupColumnDef: {
headerName: "Gold Medals",
minWidth: 220,
cellRendererParams: {
suppressCount: true,
innerRenderer: CustomMedalCellRenderer,
},
},
// optional as 'singleColumn' is the default group display type
groupDisplayType: "singleColumn",
};
var gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((response) => response.json())
.then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
.imgSpan {
display: flex;
height: 40px;
width: 100%;
align-items: center;
}
.medalIcon {
display: block;
width: 15px;
height: auto;
max-height: 50%;
}
import { ICellRendererParams } from 'ag-grid-community';
export function CustomMedalCellRenderer(params: ICellRendererParams) {
const priceSpan = document.createElement('span');
priceSpan.setAttribute('class', 'imgSpan');
for (let i = 0; i < params.value ?? 0; i++) {
const priceElement = document.createElement('img');
priceElement.src = `https://www.ag-grid.com/example-assets/gold-star.png`;
priceElement.setAttribute('class', 'medalIcon');
priceSpan.appendChild(priceElement);
}
return priceSpan;
}
<div id="myGrid" style="height: 100%"></div>
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} The example above uses the following configuration to provide a custom inner renderer to the group column:
const gridOptions = {
autoGroupColumnDef: {
cellRendererParams: {
innerRenderer: CustomMedalCellRenderer,
},
},
// other grid options ...
} Custom Cell Renderer Copy Link
The Group Cell Renderer can be entirely replaced with a Custom Cell Component by setting the cellRenderer property on the autoGroupColumnDef configuration.
import {
CellDoubleClickedEvent,
CellKeyDownEvent,
ClientSideRowModelModule,
ColDef,
GridApi,
GridOptions,
ModuleRegistry,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
import { CustomGroupCellRenderer } from "./customGroupCellRenderer";
import { IOlympicData } from "./interfaces";
// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([ClientSideRowModelModule, RowGroupingModule]);
const columnDefs: ColDef[] = [
{
field: "country",
rowGroup: true,
hide: true,
},
{
field: "year",
rowGroup: true,
hide: true,
},
{
field: "athlete",
},
{
field: "total",
aggFunc: "sum",
},
];
let gridApi: GridApi<IOlympicData>;
const gridOptions: GridOptions<IOlympicData> = {
columnDefs: columnDefs,
autoGroupColumnDef: {
cellRenderer: CustomGroupCellRenderer,
},
defaultColDef: {
flex: 1,
minWidth: 120,
},
groupDefaultExpanded: 1,
onCellDoubleClicked: (params: CellDoubleClickedEvent<IOlympicData, any>) => {
if (params.colDef.showRowGroup) {
params.node.setExpanded(!params.node.expanded);
}
},
onCellKeyDown: (params: CellKeyDownEvent<IOlympicData, any>) => {
if (!("colDef" in params)) {
return;
}
if (!(params.event instanceof KeyboardEvent)) {
return;
}
if (params.event.code !== "Enter") {
return;
}
if (params.colDef.showRowGroup) {
params.node.setExpanded(!params.node.expanded);
}
},
};
const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
fetch("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
.then((response) => response.json())
.then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
import { ICellRendererComp, ICellRendererParams, IRowNode, RowEvent } from 'ag-grid-community';
export class CustomGroupCellRenderer implements ICellRendererComp {
eGui: HTMLElement | undefined;
eGroupStatus: HTMLElement | undefined;
eValueContainer: HTMLElement | undefined;
node: IRowNode | undefined;
onClick = () => {
this.node!.setExpanded(!this.node!.expanded);
};
onExpandedChanged = (params: RowEvent) => {
this.eGroupStatus!.setAttribute(
'style',
`cursor: pointer;transform: ${params.node.expanded ? 'rotate(90deg)' : 'rotate(0deg)'};display: inline-block`
);
};
init(params: ICellRendererParams) {
this.node = params.node;
this.eGui = document.createElement('div');
const paddingLeft = params.node.level * 15;
this.eGui.setAttribute('style', `padding-left: ${paddingLeft}px`);
if (this.node.group) {
this.eGroupStatus = document.createElement('div');
this.eGroupStatus.setAttribute(
'style',
`cursor: pointer;transform: ${params.node.expanded ? 'rotate(90deg)' : 'rotate(0deg)'};display: inline-block`
);
this.eGroupStatus.innerHTML = '→';
this.eGroupStatus.setAttribute('class', 'eGroupStatus');
this.eGroupStatus.addEventListener('click', this.onClick);
this.eGui.appendChild(this.eGroupStatus);
this.node.addEventListener('expandedChanged', this.onExpandedChanged);
}
this.eGui.append(' ');
this.eValueContainer = document.createElement('span');
this.eValueContainer.textContent = params.value == null ? '' : params.value;
this.eValueContainer.setAttribute('class', 'eValueContainer');
this.eGui.appendChild(this.eValueContainer);
}
getGui() {
return this.eGui!;
}
refresh(params: ICellRendererParams): boolean {
this.eValueContainer!.textContent = params.value == null ? '' : params.value;
return true;
}
destroy(): void {
if (this.eGroupStatus) {
this.node!.removeEventListener('expandedChanged', this.onExpandedChanged);
this.eGroupStatus.removeEventListener('click', this.onClick);
}
}
}
<div id="myGrid" style="height: 100%"></div>
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} It is also possible to Determine Cell Renderers Dynamically.
Filtering Copy Link
The grid filters leaf rows by default, if all of a groups children are filtered out, the group is also hidden.
Inherit Row Grouped Columns Filters Copy Link
The single group column content changes depending on the columns which have row grouping enabled. The agGroupColumnFilter can be used to display the filters for the columns with row grouping enabled.
import {
ClientSideRowModelModule,
GridApi,
GridOptions,
ModuleRegistry,
NumberFilterModule,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import {
GroupFilterModule,
RowGroupingModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberFilterModule,
ClientSideRowModelModule,
RowGroupingModule,
SetFilterModule,
GroupFilterModule,
]);
let gridApi: GridApi<IOlympicData>;
const gridOptions: GridOptions<IOlympicData> = {
columnDefs: [
{ field: "country", rowGroup: true, hide: true, filter: true },
{ field: "year", rowGroup: true, hide: true, filter: true },
{ field: "athlete" },
{ field: "sport" },
{ field: "total" },
],
defaultColDef: {
flex: 1,
minWidth: 100,
},
autoGroupColumnDef: {
minWidth: 200,
filter: "agGroupColumnFilter",
floatingFilter: true,
},
groupDefaultExpanded: 1,
onGridReady: (params) => {
params.api.showColumnFilter("ag-Grid-AutoColumn");
},
};
var gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((response) => response.json())
.then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
<div id="myGrid" style="height: 100%"></div>
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} The example above demonstrates the following configuration to enable the group column filter:
const gridOptions = {
autoGroupColumnDef: {
filter: 'agGroupColumnFilter',
floatingFilter: true,
},
// other grid options ...
}When accessing filter instances via API, access the filters on the columns with row grouping.
Tree Filter Copy Link
The agSetColumnFilter can be used to filter the group column in a Tree List, representing the hierarchy of the row groups.
import {
ClientSideRowModelModule,
GridApi,
GridOptions,
KeyCreatorParams,
ModuleRegistry,
NumberFilterModule,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule, SetFilterModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberFilterModule,
ClientSideRowModelModule,
RowGroupingModule,
SetFilterModule,
]);
let gridApi: GridApi<IOlympicData>;
const gridOptions: GridOptions<IOlympicData> = {
columnDefs: [
{ field: "country", rowGroup: true, hide: true, filter: true },
{ field: "year", rowGroup: true, hide: true, filter: true },
{ field: "athlete" },
{ field: "sport" },
{ field: "total" },
],
defaultColDef: {
flex: 1,
minWidth: 100,
},
autoGroupColumnDef: {
minWidth: 200,
filter: true,
floatingFilter: true,
filterValueGetter: (params) => params.data?.athlete,
filterParams: {
treeList: true,
keyCreator: (params: KeyCreatorParams) =>
params.value ? params.value.join("#") : null,
},
},
groupDefaultExpanded: 1,
onGridReady: (params) => {
params.api.showColumnFilter("ag-Grid-AutoColumn");
},
};
var gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((response) => response.json())
.then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
<div id="myGrid" style="height: 100%"></div>
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} The tree filter needs a value for each leaf row. In absence of a field or valueGetter on the group column, provide a filterValueGetter to the group column definition.
The example above demonstrates the following configuration to enable the tree set filter:
const gridOptions = {
autoGroupColumnDef: {
filter: 'agSetColumnFilter',
filterValueGetter: (params) => params.data.athlete,
filterParams: {
treeList: true,
keyCreator: (params) => (params.value ? params.value.join('#') : null),
},
},
// other grid options ...
}Refer to the Tree List Filter documentation for further configuration options.
Text Filtering Copy Link
Providing a filter value getter to the group column allows for a simple string search of any group level.
import {
ClientSideRowModelModule,
GridApi,
GridOptions,
ModuleRegistry,
NumberFilterModule,
TextFilterModule,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberFilterModule,
ClientSideRowModelModule,
RowGroupingModule,
TextFilterModule,
]);
let gridApi: GridApi<IOlympicData>;
const gridOptions: GridOptions<IOlympicData> = {
columnDefs: [
{ field: "country", rowGroup: true, hide: true, filter: true },
{ field: "year", rowGroup: true, hide: true, filter: true },
{ field: "athlete" },
{ field: "sport" },
{ field: "total" },
],
defaultColDef: {
flex: 1,
minWidth: 100,
},
autoGroupColumnDef: {
minWidth: 200,
filter: "agTextColumnFilter",
floatingFilter: true,
filterValueGetter: (params) => params.node?.parent?.getRoute(),
},
groupDefaultExpanded: 1,
};
var gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((response) => response.json())
.then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
<div id="myGrid" style="height: 100%"></div>
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} The example above demonstrates using a filter value getter which returns an array of ancestor row keys. This enables searching for any group value containing the filter text:
const gridOptions = {
autoGroupColumnDef: {
filter: 'agTextColumnFilter',
filterValueGetter: (params) => params.node.parent.getRoute(),
},
// other grid options ...
}

Display the group structure with a single generated column in the grid.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
RowGroupingDisplayType,
enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([ClientSideRowModelModule, RowGroupingModule]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[autoGroupColumnDef]="autoGroupColumnDef"
[groupDisplayType]="groupDisplayType"
[groupDefaultExpanded]="groupDefaultExpanded"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ field: "country", rowGroup: true, hide: true },
{ field: "year", rowGroup: true, hide: true },
{ field: "athlete" },
{ field: "sport" },
{ field: "total" },
];
defaultColDef: ColDef = {
flex: 1,
minWidth: 100,
};
autoGroupColumnDef: AutoGroupColumnDef = {
minWidth: 200,
};
groupDisplayType: RowGroupingDisplayType = "singleColumn";
groupDefaultExpanded = 1;
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Enabling a Single Group Column Copy Link
The example above demonstrates that both country and year are grouped. Only a single group column is used to display the group value cells.
The Single Group Column is enabled by default, but it can be set explicitly by setting the groupDisplayType grid option to "singleColumn" as shown below:
<ag-grid-angular
[groupDisplayType]="groupDisplayType"
/* other grid options ... */ />
this.groupDisplayType = 'singleColumn'; Configuration Copy Link
The Single Group Column is added to the grid when row grouping is present, and can be configured via the autoGroupColumnDef grid option to define Column Options.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
RowGroupingDisplayType,
enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([ClientSideRowModelModule, RowGroupingModule]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[autoGroupColumnDef]="autoGroupColumnDef"
[groupDisplayType]="groupDisplayType"
[groupDefaultExpanded]="groupDefaultExpanded"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ field: "country", rowGroup: true, hide: true },
{ field: "year", rowGroup: true, hide: true },
{ field: "sport" },
{ field: "total" },
];
defaultColDef: ColDef = {
flex: 1,
minWidth: 100,
};
autoGroupColumnDef: AutoGroupColumnDef = {
headerName: "My Group",
field: "athlete",
minWidth: 220,
cellRendererParams: {
suppressCount: true,
},
};
groupDisplayType: RowGroupingDisplayType = "singleColumn";
groupDefaultExpanded = -1;
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} The example above uses the configuration demonstrated below to change the columns header name, apply a minimum width, and display athlete values in the leaf level rows. It also Configures the Group Cell Component using the cellRendererParams option to remove the count from each row group.
<ag-grid-angular
[autoGroupColumnDef]="autoGroupColumnDef"
/* other grid options ... */ />
this.autoGroupColumnDef = {
headerName: 'My Group',
field: 'athlete',
minWidth: 220,
cellRendererParams: {
suppressCount: true,
}
}; Cell Component Copy Link
The group column uses the agGroupCellRenderer component to display the group information, as well as the chevron control for expanding and collapsing rows. The renderer also embeds the grouped columns renderer and displays this inside of the group cell.
This can be configured with several Group Renderer Properties using the autoGroupColumnDef property cellRendererParams. The example below removes the row count and also Configures Row Selection to enable checkboxes for row selection.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
RowGroupingDisplayType,
RowSelectionModule,
RowSelectionOptions,
enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
RowSelectionModule,
ClientSideRowModelModule,
RowGroupingModule,
]);
import { CustomMedalCellRenderer } from "./customMedalCellRenderer.component";
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular, CustomMedalCellRenderer],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[autoGroupColumnDef]="autoGroupColumnDef"
[groupDisplayType]="groupDisplayType"
[rowSelection]="rowSelection"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ field: "total", rowGroup: true, cellRenderer: CustomMedalCellRenderer },
{ field: "year" },
{ field: "athlete" },
{ field: "sport" },
];
defaultColDef: ColDef = {
flex: 1,
minWidth: 100,
};
autoGroupColumnDef: AutoGroupColumnDef = {
headerName: "Gold Medals",
minWidth: 240,
cellRendererParams: {
suppressCount: true,
},
};
groupDisplayType: RowGroupingDisplayType = "singleColumn";
rowSelection: RowSelectionOptions | "single" | "multiple" = {
mode: "singleRow",
checkboxLocation: "autoGroupColumn",
};
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
.imgSpan {
display: flex;
height: 40px;
width: 100%;
align-items: center;
}
.medalIcon {
display: block;
width: 15px;
height: auto;
max-height: 50%;
}
import { ChangeDetectionStrategy, Component, signal } from '@angular/core';
import type { ICellRendererAngularComp } from 'ag-grid-angular';
import type { ICellRendererParams } from 'ag-grid-community';
@Component({
standalone: true,
changeDetection: ChangeDetectionStrategy.OnPush,
template: `
<span :class="imgSpan">
@for (number of arr(); track $index) {
<img [src]="src" :class="medalIcon" />
}
</span>
`,
})
export class CustomMedalCellRenderer implements ICellRendererAngularComp {
src: string = 'https://www.ag-grid.com/example-assets/gold-star.png';
arr = signal<any[]>([]);
agInit(params: ICellRendererParams): void {
this.refresh(params);
}
refresh(params: ICellRendererParams): boolean {
this.arr.set(Array(Number(params.value ?? 0)).fill(''));
return true;
}
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} The example above demonstrates the following configuration:
<ag-grid-angular
[columnDefs]="columnDefs"
[autoGroupColumnDef]="autoGroupColumnDef"
[rowSelection]="rowSelection"
/* other grid options ... */ />
this.columnDefs = [
{ field: 'total', rowGroup: true, cellRenderer: CustomMedalCellRenderer },
// ... other column definitions
];
this.autoGroupColumnDef = {
cellRendererParams: {
suppressCount: true,
}
};
this.rowSelection = {
mode: 'singleRow',
checkboxLocation: 'autoGroupColumn',
}; Configurable Options Copy Link
Set to true to not include any padding (indentation) in the child rows. |
Set to true to suppress expand on double click. |
Set to true to suppress expand on â” Enter |
The value getter for the total row text. Can be a function or expression. |
If true, count is not displayed beside the name. |
The renderer to use for inside the cell (after grouping functions are added) |
Additional params to customise to the innerRenderer. |
Callback to enable different innerRenderers to be used based of value of params. |
Checkbox Selection Copy Link
The agGroupCellRenderer can be configured to show checkboxes for row selection. Setting the Row Selection checkboxLocation property to 'autoGroupColumn' hides the Checkbox Column instead using the group cell renderer to display checkboxes.
Setting groupSelects to 'descendants' causes selecting a group row to also select all of its children.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
RowSelectionModule,
RowSelectionOptions,
enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
RowSelectionModule,
ClientSideRowModelModule,
RowGroupingModule,
]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[autoGroupColumnDef]="autoGroupColumnDef"
[rowSelection]="rowSelection"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ field: "country", rowGroup: true },
{ field: "athlete" },
{ field: "year" },
{ field: "sport" },
];
defaultColDef: ColDef = {
flex: 1,
minWidth: 100,
};
autoGroupColumnDef: AutoGroupColumnDef = {
minWidth: 220,
};
rowSelection: RowSelectionOptions | "single" | "multiple" = {
mode: "multiRow",
groupSelects: "descendants",
selectAll: "all",
checkboxLocation: "autoGroupColumn",
};
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} The example above demonstrates the following configuration:
<ag-grid-angular
[rowSelection]="rowSelection"
/* other grid options ... */ />
this.rowSelection = {
mode: 'multiRow',
groupSelects: 'descendants',
selectAll: 'all',
checkboxLocation: 'autoGroupColumn',
}; Custom Inner Renderer Copy Link
When using the group cell renderer, the agGroupCellRenderer component will inherit the grouped columns renderer and display this inside of the group cell, adjacent to any configured checkboxes, cell count, and the expand/collapse chevron control.
This inner renderer can be overridden with a Custom Cell Component by setting the innerRenderer and innerRendererParams properties on the cellRendererParams configuration.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
RowGroupingDisplayType,
enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([ClientSideRowModelModule, RowGroupingModule]);
import { CustomMedalCellRenderer } from "./customMedalCellRenderer.component";
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular, CustomMedalCellRenderer],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[autoGroupColumnDef]="autoGroupColumnDef"
[groupDisplayType]="groupDisplayType"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ field: "total", rowGroup: true },
{ field: "country" },
{ field: "year" },
{ field: "athlete" },
{ field: "sport" },
];
defaultColDef: ColDef = {
flex: 1,
minWidth: 100,
};
autoGroupColumnDef: AutoGroupColumnDef = {
headerName: "Gold Medals",
minWidth: 220,
cellRendererParams: {
suppressCount: true,
innerRenderer: CustomMedalCellRenderer,
},
};
groupDisplayType: RowGroupingDisplayType = "singleColumn";
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
.imgSpan {
display: flex;
height: 40px;
width: 100%;
align-items: center;
}
.medalIcon {
display: block;
width: 15px;
height: auto;
max-height: 50%;
}
import { ChangeDetectionStrategy, Component, signal } from '@angular/core';
import type { ICellRendererAngularComp } from 'ag-grid-angular';
import type { ICellRendererParams } from 'ag-grid-community';
@Component({
standalone: true,
changeDetection: ChangeDetectionStrategy.OnPush,
template: `
<span :class="imgSpan">
@for (number of arr(); track $index) {
<img [src]="src" :class="medalIcon" />
}
</span>
`,
})
export class CustomMedalCellRenderer implements ICellRendererAngularComp {
src: string = 'https://www.ag-grid.com/example-assets/gold-star.png';
arr = signal<any[]>([]);
agInit(params: ICellRendererParams): void {
this.refresh(params);
}
refresh(params: ICellRendererParams): boolean {
this.arr.set(Array(Number(params.value ?? 0)).fill(''));
return true;
}
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} The example above uses the following configuration to provide a custom inner renderer to the group column:
<ag-grid-angular
[autoGroupColumnDef]="autoGroupColumnDef"
/* other grid options ... */ />
this.autoGroupColumnDef = {
cellRendererParams: {
innerRenderer: CustomMedalCellRenderer,
},
}; Custom Cell Renderer Copy Link
The Group Cell Renderer can be entirely replaced with a Custom Cell Component by setting the cellRenderer property on the autoGroupColumnDef configuration.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
AutoGroupColumnDef,
CellDoubleClickedEvent,
CellKeyDownEvent,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([ClientSideRowModelModule, RowGroupingModule]);
import { CustomGroupCellRenderer } from "./customGroupCellRenderer.component";
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular, CustomGroupCellRenderer],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[autoGroupColumnDef]="autoGroupColumnDef"
[defaultColDef]="defaultColDef"
[groupDefaultExpanded]="groupDefaultExpanded"
[rowData]="rowData"
(cellDoubleClicked)="onCellDoubleClicked($event)"
(cellKeyDown)="onCellKeyDown($event)"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{
field: "country",
rowGroup: true,
hide: true,
},
{
field: "year",
rowGroup: true,
hide: true,
},
{
field: "athlete",
},
{
field: "total",
aggFunc: "sum",
},
];
autoGroupColumnDef: AutoGroupColumnDef = {
cellRenderer: CustomGroupCellRenderer,
};
defaultColDef: ColDef = {
flex: 1,
minWidth: 120,
};
groupDefaultExpanded = 1;
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onCellDoubleClicked(params: CellDoubleClickedEvent<IOlympicData, any>) {
if (params.colDef.showRowGroup) {
params.node.setExpanded(!params.node.expanded);
}
}
onCellKeyDown(params: CellKeyDownEvent<IOlympicData, any>) {
if (!("colDef" in params)) {
return;
}
if (!(params.event instanceof KeyboardEvent)) {
return;
}
if (params.event.code !== "Enter") {
return;
}
if (params.colDef.showRowGroup) {
params.node.setExpanded(!params.node.expanded);
}
}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
import { ChangeDetectionStrategy, Component, signal } from '@angular/core';
import type { ICellRendererAngularComp } from 'ag-grid-angular';
import type { ICellRendererParams, IRowNode } from 'ag-grid-community';
@Component({
standalone: true,
changeDetection: ChangeDetectionStrategy.OnPush,
template: `
<div [style.paddingLeft.px]="paddingLeft()">
@if (isGroup()) {
<div
[style.transform]="rotation()"
[style.cursor]="'pointer'"
[style.display]="'inline-block'"
(click)="onClick()"
>
→
</div>
}
{{ value() }}
</div>
`,
})
export class CustomGroupCellRenderer implements ICellRendererAngularComp {
private node!: IRowNode;
value = signal<string>('');
paddingLeft = signal(0);
isGroup = signal(false);
rotation = signal('');
agInit(params: ICellRendererParams): void {
this.value.set(params.value);
this.node = params.node;
this.paddingLeft.set(this.node.level * 15);
this.isGroup.set(!!this.node.group);
this.rotation.set(this.node.expanded ? 'rotate(90deg)' : 'rotate(0deg)');
this.node.addEventListener('expandedChanged', this.onExpand);
}
refresh(params: ICellRendererParams) {
return false;
}
destroy() {
this.node.removeEventListener('expandedChanged', this.onExpand);
}
onClick() {
this.node.setExpanded(!this.node.expanded);
}
onExpand = () => {
this.rotation.set(this.node.expanded ? 'rotate(90deg)' : 'rotate(0deg)');
};
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} It is also possible to Determine Cell Renderers Dynamically.
Filtering Copy Link
The grid filters leaf rows by default, if all of a groups children are filtered out, the group is also hidden.
Inherit Row Grouped Columns Filters Copy Link
The single group column content changes depending on the columns which have row grouping enabled. The agGroupColumnFilter can be used to display the filters for the columns with row grouping enabled.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
enableDevValidations,
} from "ag-grid-community";
import {
GroupFilterModule,
RowGroupingModule,
SetFilterModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberFilterModule,
ClientSideRowModelModule,
RowGroupingModule,
SetFilterModule,
GroupFilterModule,
]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[autoGroupColumnDef]="autoGroupColumnDef"
[groupDefaultExpanded]="groupDefaultExpanded"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ field: "country", rowGroup: true, hide: true, filter: true },
{ field: "year", rowGroup: true, hide: true, filter: true },
{ field: "athlete" },
{ field: "sport" },
{ field: "total" },
];
defaultColDef: ColDef = {
flex: 1,
minWidth: 100,
};
autoGroupColumnDef: AutoGroupColumnDef = {
minWidth: 200,
filter: "agGroupColumnFilter",
floatingFilter: true,
};
groupDefaultExpanded = 1;
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent<IOlympicData>) {
params.api.showColumnFilter("ag-Grid-AutoColumn");
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} The example above demonstrates the following configuration to enable the group column filter:
<ag-grid-angular
[autoGroupColumnDef]="autoGroupColumnDef"
/* other grid options ... */ />
this.autoGroupColumnDef = {
filter: 'agGroupColumnFilter',
floatingFilter: true,
};When accessing filter instances via API, access the filters on the columns with row grouping.
Tree Filter Copy Link
The agSetColumnFilter can be used to filter the group column in a Tree List, representing the hierarchy of the row groups.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
KeyCreatorParams,
ModuleRegistry,
NumberFilterModule,
enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule, SetFilterModule } from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberFilterModule,
ClientSideRowModelModule,
RowGroupingModule,
SetFilterModule,
]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[autoGroupColumnDef]="autoGroupColumnDef"
[groupDefaultExpanded]="groupDefaultExpanded"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ field: "country", rowGroup: true, hide: true, filter: true },
{ field: "year", rowGroup: true, hide: true, filter: true },
{ field: "athlete" },
{ field: "sport" },
{ field: "total" },
];
defaultColDef: ColDef = {
flex: 1,
minWidth: 100,
};
autoGroupColumnDef: AutoGroupColumnDef = {
minWidth: 200,
filter: true,
floatingFilter: true,
filterValueGetter: (params) => params.data?.athlete,
filterParams: {
treeList: true,
keyCreator: (params: KeyCreatorParams) =>
params.value ? params.value.join("#") : null,
},
};
groupDefaultExpanded = 1;
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent<IOlympicData>) {
params.api.showColumnFilter("ag-Grid-AutoColumn");
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} The tree filter needs a value for each leaf row. In absence of a field or valueGetter on the group column, provide a filterValueGetter to the group column definition.
The example above demonstrates the following configuration to enable the tree set filter:
<ag-grid-angular
[autoGroupColumnDef]="autoGroupColumnDef"
/* other grid options ... */ />
this.autoGroupColumnDef = {
filter: 'agSetColumnFilter',
filterValueGetter: (params) => params.data.athlete,
filterParams: {
treeList: true,
keyCreator: (params) => (params.value ? params.value.join('#') : null),
},
};Refer to the Tree List Filter documentation for further configuration options.
Text Filtering Copy Link
Providing a filter value getter to the group column allows for a simple string search of any group level.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberFilterModule,
ClientSideRowModelModule,
RowGroupingModule,
TextFilterModule,
]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[autoGroupColumnDef]="autoGroupColumnDef"
[groupDefaultExpanded]="groupDefaultExpanded"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ field: "country", rowGroup: true, hide: true, filter: true },
{ field: "year", rowGroup: true, hide: true, filter: true },
{ field: "athlete" },
{ field: "sport" },
{ field: "total" },
];
defaultColDef: ColDef = {
flex: 1,
minWidth: 100,
};
autoGroupColumnDef: AutoGroupColumnDef = {
minWidth: 200,
filter: "agTextColumnFilter",
floatingFilter: true,
filterValueGetter: (params) => params.node?.parent?.getRoute(),
};
groupDefaultExpanded = 1;
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} The example above demonstrates using a filter value getter which returns an array of ancestor row keys. This enables searching for any group value containing the filter text:
<ag-grid-angular
[autoGroupColumnDef]="autoGroupColumnDef"
/* other grid options ... */ />
this.autoGroupColumnDef = {
filter: 'agTextColumnFilter',
filterValueGetter: (params) => params.node.parent.getRoute(),
};

Display the group structure with a single generated column in the grid.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
RowGroupingDisplayType,
enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([ClientSideRowModelModule, RowGroupingModule]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:autoGroupColumnDef="autoGroupColumnDef"
:groupDisplayType="groupDisplayType"
:groupDefaultExpanded="groupDefaultExpanded"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "country", rowGroup: true, hide: true },
{ field: "year", rowGroup: true, hide: true },
{ field: "athlete" },
{ field: "sport" },
{ field: "total" },
]);
const defaultColDef = ref<ColDef>({
flex: 1,
minWidth: 100,
});
const autoGroupColumnDef = ref<AutoGroupColumnDef>({
minWidth: 200,
});
const groupDisplayType = ref<RowGroupingDisplayType>("singleColumn");
const groupDefaultExpanded = ref(1);
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
autoGroupColumnDef,
groupDisplayType,
groupDefaultExpanded,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
Enabling a Single Group Column Copy Link
The example above demonstrates that both country and year are grouped. Only a single group column is used to display the group value cells.
The Single Group Column is enabled by default, but it can be set explicitly by setting the groupDisplayType grid option to "singleColumn" as shown below:
<ag-grid-vue
:groupDisplayType="groupDisplayType"
/* other grid options ... */>
</ag-grid-vue>
this.groupDisplayType = 'singleColumn'; Configuration Copy Link
The Single Group Column is added to the grid when row grouping is present, and can be configured via the autoGroupColumnDef grid option to define Column Options.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
RowGroupingDisplayType,
enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([ClientSideRowModelModule, RowGroupingModule]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:autoGroupColumnDef="autoGroupColumnDef"
:groupDisplayType="groupDisplayType"
:groupDefaultExpanded="groupDefaultExpanded"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "country", rowGroup: true, hide: true },
{ field: "year", rowGroup: true, hide: true },
{ field: "sport" },
{ field: "total" },
]);
const defaultColDef = ref<ColDef>({
flex: 1,
minWidth: 100,
});
const autoGroupColumnDef = ref<AutoGroupColumnDef>({
headerName: "My Group",
field: "athlete",
minWidth: 220,
cellRendererParams: {
suppressCount: true,
},
});
const groupDisplayType = ref<RowGroupingDisplayType>("singleColumn");
const groupDefaultExpanded = ref(-1);
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
autoGroupColumnDef,
groupDisplayType,
groupDefaultExpanded,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
The example above uses the configuration demonstrated below to change the columns header name, apply a minimum width, and display athlete values in the leaf level rows. It also Configures the Group Cell Component using the cellRendererParams option to remove the count from each row group.
<ag-grid-vue
:autoGroupColumnDef="autoGroupColumnDef"
/* other grid options ... */>
</ag-grid-vue>
this.autoGroupColumnDef = {
headerName: 'My Group',
field: 'athlete',
minWidth: 220,
cellRendererParams: {
suppressCount: true,
}
}; Cell Component Copy Link
The group column uses the agGroupCellRenderer component to display the group information, as well as the chevron control for expanding and collapsing rows. The renderer also embeds the grouped columns renderer and displays this inside of the group cell.
This can be configured with several Group Renderer Properties using the autoGroupColumnDef property cellRendererParams. The example below removes the row count and also Configures Row Selection to enable checkboxes for row selection.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
RowGroupingDisplayType,
RowSelectionModule,
RowSelectionOptions,
enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
import CustomMedalCellRenderer from "./customMedalCellRendererVue";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([
RowSelectionModule,
ClientSideRowModelModule,
RowGroupingModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:autoGroupColumnDef="autoGroupColumnDef"
:groupDisplayType="groupDisplayType"
:rowSelection="rowSelection"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
CustomMedalCellRenderer,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{
field: "total",
rowGroup: true,
cellRenderer: "CustomMedalCellRenderer",
},
{ field: "year" },
{ field: "athlete" },
{ field: "sport" },
]);
const defaultColDef = ref<ColDef>({
flex: 1,
minWidth: 100,
});
const autoGroupColumnDef = ref<AutoGroupColumnDef>({
headerName: "Gold Medals",
minWidth: 240,
cellRendererParams: {
suppressCount: true,
},
});
const groupDisplayType = ref<RowGroupingDisplayType>("singleColumn");
const rowSelection = ref<RowSelectionOptions | "single" | "multiple">({
mode: "singleRow",
checkboxLocation: "autoGroupColumn",
});
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
autoGroupColumnDef,
groupDisplayType,
rowSelection,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
.imgSpan {
display: flex;
height: 40px;
width: 100%;
align-items: center;
}
.medalIcon {
display: block;
width: 15px;
height: auto;
max-height: 50%;
}
export default {
template: `<span class="imgSpan">
<img v-for="images in arr" :src="src" class="medalIcon" />
</span>`,
data: function () {
return {
arr: [],
src: 'https://www.ag-grid.com/example-assets/gold-star.png',
};
},
beforeMount() {
this.updateDisplay(this.params);
},
methods: {
refresh(params) {
this.updateDisplay(params);
},
updateDisplay(params) {
this.arr = new Array(params.value ?? 0);
},
},
};
The example above demonstrates the following configuration:
<ag-grid-vue
:columnDefs="columnDefs"
:autoGroupColumnDef="autoGroupColumnDef"
:rowSelection="rowSelection"
/* other grid options ... */>
</ag-grid-vue>
this.columnDefs = [
{ field: 'total', rowGroup: true, cellRenderer: CustomMedalCellRenderer },
// ... other column definitions
];
this.autoGroupColumnDef = {
cellRendererParams: {
suppressCount: true,
}
};
this.rowSelection = {
mode: 'singleRow',
checkboxLocation: 'autoGroupColumn',
}; Configurable Options Copy Link
Set to true to not include any padding (indentation) in the child rows. |
Set to true to suppress expand on double click. |
Set to true to suppress expand on â” Enter |
The value getter for the total row text. Can be a function or expression. |
If true, count is not displayed beside the name. |
The renderer to use for inside the cell (after grouping functions are added) |
Additional params to customise to the innerRenderer. |
Callback to enable different innerRenderers to be used based of value of params. |
Checkbox Selection Copy Link
The agGroupCellRenderer can be configured to show checkboxes for row selection. Setting the Row Selection checkboxLocation property to 'autoGroupColumn' hides the Checkbox Column instead using the group cell renderer to display checkboxes.
Setting groupSelects to 'descendants' causes selecting a group row to also select all of its children.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
RowSelectionModule,
RowSelectionOptions,
enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([
RowSelectionModule,
ClientSideRowModelModule,
RowGroupingModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:autoGroupColumnDef="autoGroupColumnDef"
:rowSelection="rowSelection"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "country", rowGroup: true },
{ field: "athlete" },
{ field: "year" },
{ field: "sport" },
]);
const defaultColDef = ref<ColDef>({
flex: 1,
minWidth: 100,
});
const autoGroupColumnDef = ref<AutoGroupColumnDef>({
minWidth: 220,
});
const rowSelection = ref<RowSelectionOptions | "single" | "multiple">({
mode: "multiRow",
groupSelects: "descendants",
selectAll: "all",
checkboxLocation: "autoGroupColumn",
});
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
autoGroupColumnDef,
rowSelection,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
The example above demonstrates the following configuration:
<ag-grid-vue
:rowSelection="rowSelection"
/* other grid options ... */>
</ag-grid-vue>
this.rowSelection = {
mode: 'multiRow',
groupSelects: 'descendants',
selectAll: 'all',
checkboxLocation: 'autoGroupColumn',
}; Custom Inner Renderer Copy Link
When using the group cell renderer, the agGroupCellRenderer component will inherit the grouped columns renderer and display this inside of the group cell, adjacent to any configured checkboxes, cell count, and the expand/collapse chevron control.
This inner renderer can be overridden with a Custom Cell Component by setting the innerRenderer and innerRendererParams properties on the cellRendererParams configuration.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import type { ColDef, GridApi, GridReadyEvent } from "ag-grid-community";
import {
ClientSideRowModelModule,
ModuleRegistry,
enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
import { AgGridVue } from "ag-grid-vue3";
import CustomMedalCellRenderer from "./customMedalCellRenderer";
import "./styles.css";
// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([ClientSideRowModelModule, RowGroupingModule]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
:columnDefs="columnDefs"
@grid-ready="onGridReady"
:defaultColDef="defaultColDef"
:autoGroupColumnDef="autoGroupColumnDef"
:groupDisplayType="groupDisplayType"
:rowData="rowData">
</ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
CustomMedalCellRenderer,
},
setup(props) {
const columnDefs = ref<ColDef[]>([
{ field: "total", rowGroup: true },
{ field: "country" },
{ field: "year" },
{ field: "athlete" },
{ field: "sport" },
]);
const gridApi = shallowRef<GridApi | null>(null);
const defaultColDef = ref<ColDef>({
flex: 1,
minWidth: 100,
});
const autoGroupColumnDef = ref<ColDef>({
headerName: "Gold Medals",
minWidth: 220,
cellRendererParams: {
suppressCount: true,
innerRenderer: "CustomMedalCellRenderer",
},
});
const groupDisplayType = ref(null);
const rowData = ref(null);
onBeforeMount(() => {
groupDisplayType.value = "singleColumn";
});
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
columnDefs,
gridApi,
defaultColDef,
autoGroupColumnDef,
groupDisplayType,
rowData,
onGridReady,
};
},
});
createApp(VueExample).mount("#app");
.imgSpan {
display: flex;
height: 40px;
width: 100%;
align-items: center;
}
.medalIcon {
display: block;
width: 15px;
height: auto;
max-height: 50%;
}
import type { RefreshCellsParams } from "ag-grid-community";
export default {
template: `
<span class="imgSpan">
<img v-for="images in arr" :src="src" class="medalIcon" />
</span>
`,
data: function () {
return {
arr: [],
src: "https://www.ag-grid.com/example-assets/gold-star.png",
};
},
beforeMount() {
this.updateDisplay(this.params);
},
methods: {
refresh(params: RefreshCellsParams) {
this.updateDisplay(params);
},
updateDisplay(params) {
this.arr = new Array(params.value ?? 0);
},
},
};
The example above uses the following configuration to provide a custom inner renderer to the group column:
<ag-grid-vue
:autoGroupColumnDef="autoGroupColumnDef"
/* other grid options ... */>
</ag-grid-vue>
this.autoGroupColumnDef = {
cellRendererParams: {
innerRenderer: CustomMedalCellRenderer,
},
}; Custom Cell Renderer Copy Link
The Group Cell Renderer can be entirely replaced with a Custom Cell Component by setting the cellRenderer property on the autoGroupColumnDef configuration.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
AutoGroupColumnDef,
CellDoubleClickedEvent,
CellKeyDownEvent,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
import CustomGroupCellRenderer from "./customGroupCellRendererVue";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([ClientSideRowModelModule, RowGroupingModule]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:autoGroupColumnDef="autoGroupColumnDef"
:defaultColDef="defaultColDef"
:groupDefaultExpanded="groupDefaultExpanded"
:rowData="rowData"
@cell-double-clicked="onCellDoubleClicked"
@cell-key-down="onCellKeyDown"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
CustomGroupCellRenderer,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{
field: "country",
rowGroup: true,
hide: true,
},
{
field: "year",
rowGroup: true,
hide: true,
},
{
field: "athlete",
},
{
field: "total",
aggFunc: "sum",
},
]);
const autoGroupColumnDef = ref<AutoGroupColumnDef>({
cellRenderer: "CustomGroupCellRenderer",
});
const defaultColDef = ref<ColDef>({
flex: 1,
minWidth: 120,
});
const groupDefaultExpanded = ref(1);
const rowData = ref<IOlympicData[]>(null);
function onCellDoubleClicked(
params: CellDoubleClickedEvent<IOlympicData, any>,
) {
if (params.colDef.showRowGroup) {
params.node.setExpanded(!params.node.expanded);
}
}
function onCellKeyDown(params: CellKeyDownEvent<IOlympicData, any>) {
if (!("colDef" in params)) {
return;
}
if (!(params.event instanceof KeyboardEvent)) {
return;
}
if (params.event.code !== "Enter") {
return;
}
if (params.colDef.showRowGroup) {
params.node.setExpanded(!params.node.expanded);
}
}
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
autoGroupColumnDef,
defaultColDef,
groupDefaultExpanded,
rowData,
onGridReady,
onCellDoubleClicked,
onCellKeyDown,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
export default {
data() {
return {
isGroup: null,
paddingLeft: null,
rotation: null,
};
},
template: `
<div
:style="{ paddingLeft: paddingLeft }"
>
<div
v-if="isGroup"
:style="{ transform: rotation, cursor: 'pointer', display: 'inline-block' }"
@click="onExpand"
>
→
</div>
{{params.value}}
</div>
`,
methods: {
onExpand() {
this.params.node.setExpanded(!this.params.node.expanded);
},
onExpandedChanged() {
this.rotation = this.params.node.expanded ? 'rotate(90deg)' : 'rotate(0deg)';
},
},
beforeMount() {
this.isGroup = this.params.node.group;
this.paddingLeft = `${this.params.node.level * 15}px`;
this.rotation = this.params.node.expanded ? 'rotate(90deg)' : 'rotate(0deg)';
this.params.node.addEventListener('expandedChanged', this.onExpandedChanged);
},
beforeDestroy() {
this.params.node.removeEventListener('expandedChanged', this.onExpandedChanged);
},
};
It is also possible to Determine Cell Renderers Dynamically.
Filtering Copy Link
The grid filters leaf rows by default, if all of a groups children are filtered out, the group is also hidden.
Inherit Row Grouped Columns Filters Copy Link
The single group column content changes depending on the columns which have row grouping enabled. The agGroupColumnFilter can be used to display the filters for the columns with row grouping enabled.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
enableDevValidations,
} from "ag-grid-community";
import {
GroupFilterModule,
RowGroupingModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberFilterModule,
ClientSideRowModelModule,
RowGroupingModule,
SetFilterModule,
GroupFilterModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:autoGroupColumnDef="autoGroupColumnDef"
:groupDefaultExpanded="groupDefaultExpanded"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "country", rowGroup: true, hide: true, filter: true },
{ field: "year", rowGroup: true, hide: true, filter: true },
{ field: "athlete" },
{ field: "sport" },
{ field: "total" },
]);
const defaultColDef = ref<ColDef>({
flex: 1,
minWidth: 100,
});
const autoGroupColumnDef = ref<AutoGroupColumnDef>({
minWidth: 200,
filter: "agGroupColumnFilter",
floatingFilter: true,
});
const groupDefaultExpanded = ref(1);
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
params.api.showColumnFilter("ag-Grid-AutoColumn");
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
autoGroupColumnDef,
groupDefaultExpanded,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
The example above demonstrates the following configuration to enable the group column filter:
<ag-grid-vue
:autoGroupColumnDef="autoGroupColumnDef"
/* other grid options ... */>
</ag-grid-vue>
this.autoGroupColumnDef = {
filter: 'agGroupColumnFilter',
floatingFilter: true,
};When accessing filter instances via API, access the filters on the columns with row grouping.
Tree Filter Copy Link
The agSetColumnFilter can be used to filter the group column in a Tree List, representing the hierarchy of the row groups.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
KeyCreatorParams,
ModuleRegistry,
NumberFilterModule,
enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule, SetFilterModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberFilterModule,
ClientSideRowModelModule,
RowGroupingModule,
SetFilterModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:autoGroupColumnDef="autoGroupColumnDef"
:groupDefaultExpanded="groupDefaultExpanded"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "country", rowGroup: true, hide: true, filter: true },
{ field: "year", rowGroup: true, hide: true, filter: true },
{ field: "athlete" },
{ field: "sport" },
{ field: "total" },
]);
const defaultColDef = ref<ColDef>({
flex: 1,
minWidth: 100,
});
const autoGroupColumnDef = ref<AutoGroupColumnDef>({
minWidth: 200,
filter: true,
floatingFilter: true,
filterValueGetter: (params) => params.data?.athlete,
filterParams: {
treeList: true,
keyCreator: (params: KeyCreatorParams) =>
params.value ? params.value.join("#") : null,
},
});
const groupDefaultExpanded = ref(1);
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
params.api.showColumnFilter("ag-Grid-AutoColumn");
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
autoGroupColumnDef,
groupDefaultExpanded,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
The tree filter needs a value for each leaf row. In absence of a field or valueGetter on the group column, provide a filterValueGetter to the group column definition.
The example above demonstrates the following configuration to enable the tree set filter:
<ag-grid-vue
:autoGroupColumnDef="autoGroupColumnDef"
/* other grid options ... */>
</ag-grid-vue>
this.autoGroupColumnDef = {
filter: 'agSetColumnFilter',
filterValueGetter: (params) => params.data.athlete,
filterParams: {
treeList: true,
keyCreator: (params) => (params.value ? params.value.join('#') : null),
},
};Refer to the Tree List Filter documentation for further configuration options.
Text Filtering Copy Link
Providing a filter value getter to the group column allows for a simple string search of any group level.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberFilterModule,
ClientSideRowModelModule,
RowGroupingModule,
TextFilterModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:autoGroupColumnDef="autoGroupColumnDef"
:groupDefaultExpanded="groupDefaultExpanded"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "country", rowGroup: true, hide: true, filter: true },
{ field: "year", rowGroup: true, hide: true, filter: true },
{ field: "athlete" },
{ field: "sport" },
{ field: "total" },
]);
const defaultColDef = ref<ColDef>({
flex: 1,
minWidth: 100,
});
const autoGroupColumnDef = ref<AutoGroupColumnDef>({
minWidth: 200,
filter: "agTextColumnFilter",
floatingFilter: true,
filterValueGetter: (params) => params.node?.parent?.getRoute(),
});
const groupDefaultExpanded = ref(1);
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
autoGroupColumnDef,
groupDefaultExpanded,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
The example above demonstrates using a filter value getter which returns an array of ancestor row keys. This enables searching for any group value containing the filter text:
<ag-grid-vue
:autoGroupColumnDef="autoGroupColumnDef"
/* other grid options ... */>
</ag-grid-vue>
this.autoGroupColumnDef = {
filter: 'agTextColumnFilter',
filterValueGetter: (params) => params.node.parent.getRoute(),
};

Display the group structure with a single generated column in the grid.
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
ModuleRegistry,
RowGroupingDisplayType,
enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
const modules = [ClientSideRowModelModule, RowGroupingModule];
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "country", rowGroup: true, hide: true },
{ field: "year", rowGroup: true, hide: true },
{ field: "athlete" },
{ field: "sport" },
{ field: "total" },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
minWidth: 100,
};
}, []);
const autoGroupColumnDef = useMemo<AutoGroupColumnDef>(() => {
return {
minWidth: 200,
};
}, []);
const { data, loading } = useFetchJson<IOlympicData>(
"https://www.ag-grid.com/example-assets/olympic-winners.json",
);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact<IOlympicData>
rowData={data}
loading={loading}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
autoGroupColumnDef={autoGroupColumnDef}
groupDisplayType={"singleColumn"}
groupDefaultExpanded={1}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} import { useState, useEffect } from 'react';
/**
* Fetch example Json data
* Not recommended for production use!
*/
export const useFetchJson = <T,>(url:string, limit?: number) => {
const [data, setData] = useState<T[]>();
const [loading, setLoading] = useState(true);
useEffect(() => {
const fetchData = async () => {
setLoading(true);
// Note error handling is omitted here for brevity
const response = await fetch(url);
const json = await response.json();
const data = limit ? json.slice(0, limit) : json;
setData(data);
setLoading(false);
};
fetchData();
}, [url, limit]);
return { data, loading };
}; Enabling a Single Group Column Copy Link
The example above demonstrates that both country and year are grouped. Only a single group column is used to display the group value cells.
The Single Group Column is enabled by default, but it can be set explicitly by setting the groupDisplayType grid option to "singleColumn" as shown below:
const groupDisplayType = 'singleColumn';
<AgGridReact groupDisplayType={groupDisplayType} /> Configuration Copy Link
The Single Group Column is added to the grid when row grouping is present, and can be configured via the autoGroupColumnDef grid option to define Column Options.
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
ModuleRegistry,
RowGroupingDisplayType,
enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
const modules = [ClientSideRowModelModule, RowGroupingModule];
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "country", rowGroup: true, hide: true },
{ field: "year", rowGroup: true, hide: true },
{ field: "sport" },
{ field: "total" },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
minWidth: 100,
};
}, []);
const autoGroupColumnDef = useMemo<AutoGroupColumnDef>(() => {
return {
headerName: "My Group",
field: "athlete",
minWidth: 220,
cellRendererParams: {
suppressCount: true,
},
};
}, []);
const { data, loading } = useFetchJson<IOlympicData>(
"https://www.ag-grid.com/example-assets/olympic-winners.json",
);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact<IOlympicData>
rowData={data}
loading={loading}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
autoGroupColumnDef={autoGroupColumnDef}
groupDisplayType={"singleColumn"}
groupDefaultExpanded={-1}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} import { useState, useEffect } from 'react';
/**
* Fetch example Json data
* Not recommended for production use!
*/
export const useFetchJson = <T,>(url:string, limit?: number) => {
const [data, setData] = useState<T[]>();
const [loading, setLoading] = useState(true);
useEffect(() => {
const fetchData = async () => {
setLoading(true);
// Note error handling is omitted here for brevity
const response = await fetch(url);
const json = await response.json();
const data = limit ? json.slice(0, limit) : json;
setData(data);
setLoading(false);
};
fetchData();
}, [url, limit]);
return { data, loading };
}; The example above uses the configuration demonstrated below to change the columns header name, apply a minimum width, and display athlete values in the leaf level rows. It also Configures the Group Cell Component using the cellRendererParams option to remove the count from each row group.
const autoGroupColumnDef = useMemo(() => {
return {
headerName: 'My Group',
field: 'athlete',
minWidth: 220,
cellRendererParams: {
suppressCount: true,
}
};
}, []);
<AgGridReact autoGroupColumnDef={autoGroupColumnDef} /> Cell Component Copy Link
The group column uses the agGroupCellRenderer component to display the group information, as well as the chevron control for expanding and collapsing rows. The renderer also embeds the grouped columns renderer and displays this inside of the group cell.
This can be configured with several Group Renderer Properties using the autoGroupColumnDef property cellRendererParams. The example below removes the row count and also Configures Row Selection to enable checkboxes for row selection.
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
ModuleRegistry,
RowGroupingDisplayType,
RowSelectionModule,
RowSelectionOptions,
enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
import CustomMedalCellRenderer from "./customMedalCellRenderer.tsx";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
const modules = [
RowSelectionModule,
ClientSideRowModelModule,
RowGroupingModule,
];
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "total", rowGroup: true, cellRenderer: CustomMedalCellRenderer },
{ field: "year" },
{ field: "athlete" },
{ field: "sport" },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
minWidth: 100,
};
}, []);
const autoGroupColumnDef = useMemo<AutoGroupColumnDef>(() => {
return {
headerName: "Gold Medals",
minWidth: 240,
cellRendererParams: {
suppressCount: true,
},
};
}, []);
const rowSelection = useMemo<
RowSelectionOptions | "single" | "multiple"
>(() => {
return {
mode: "singleRow",
checkboxLocation: "autoGroupColumn",
};
}, []);
const { data, loading } = useFetchJson<IOlympicData>(
"https://www.ag-grid.com/example-assets/olympic-winners.json",
);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact<IOlympicData>
rowData={data}
loading={loading}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
autoGroupColumnDef={autoGroupColumnDef}
groupDisplayType={"singleColumn"}
rowSelection={rowSelection}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
.imgSpan {
display: flex;
height: 40px;
width: 100%;
align-items: center;
}
.medalIcon {
display: block;
width: 15px;
height: auto;
max-height: 50%;
}
import React from 'react';
import { CustomCellRendererProps } from 'ag-grid-react';
export default (params: CustomCellRendererProps) => {
const priceArr: any[] = new Array(params.value ?? 0).fill('');
return (
<span className="imgSpan">
{priceArr.map((_, index) => (
<img key={index} src="https://www.ag-grid.com/example-assets/gold-star.png" className="medalIcon" />
))}
</span>
);
};
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} import { useState, useEffect } from 'react';
/**
* Fetch example Json data
* Not recommended for production use!
*/
export const useFetchJson = <T,>(url:string, limit?: number) => {
const [data, setData] = useState<T[]>();
const [loading, setLoading] = useState(true);
useEffect(() => {
const fetchData = async () => {
setLoading(true);
// Note error handling is omitted here for brevity
const response = await fetch(url);
const json = await response.json();
const data = limit ? json.slice(0, limit) : json;
setData(data);
setLoading(false);
};
fetchData();
}, [url, limit]);
return { data, loading };
}; The example above demonstrates the following configuration:
const [columnDefs, setColumnDefs] = useState([
{ field: 'total', rowGroup: true, cellRenderer: CustomMedalCellRenderer },
// ... other column definitions
]);
const autoGroupColumnDef = useMemo(() => {
return {
cellRendererParams: {
suppressCount: true,
}
};
}, []);
const rowSelection = useMemo(() => {
return {
mode: 'singleRow',
checkboxLocation: 'autoGroupColumn',
};
}, []);
<AgGridReact
columnDefs={columnDefs}
autoGroupColumnDef={autoGroupColumnDef}
rowSelection={rowSelection}
/> Configurable Options Copy Link
Set to true to not include any padding (indentation) in the child rows. |
Set to true to suppress expand on double click. |
Set to true to suppress expand on â” Enter |
The value getter for the total row text. Can be a function or expression. |
If true, count is not displayed beside the name. |
The renderer to use for inside the cell (after grouping functions are added) |
Additional params to customise to the innerRenderer. |
Callback to enable different innerRenderers to be used based of value of params. |
Checkbox Selection Copy Link
The agGroupCellRenderer can be configured to show checkboxes for row selection. Setting the Row Selection checkboxLocation property to 'autoGroupColumn' hides the Checkbox Column instead using the group cell renderer to display checkboxes.
Setting groupSelects to 'descendants' causes selecting a group row to also select all of its children.
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
ModuleRegistry,
RowSelectionModule,
RowSelectionOptions,
enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
const modules = [
RowSelectionModule,
ClientSideRowModelModule,
RowGroupingModule,
];
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "country", rowGroup: true },
{ field: "athlete" },
{ field: "year" },
{ field: "sport" },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
minWidth: 100,
};
}, []);
const autoGroupColumnDef = useMemo<AutoGroupColumnDef>(() => {
return {
minWidth: 220,
};
}, []);
const rowSelection = useMemo<
RowSelectionOptions | "single" | "multiple"
>(() => {
return {
mode: "multiRow",
groupSelects: "descendants",
selectAll: "all",
checkboxLocation: "autoGroupColumn",
};
}, []);
const { data, loading } = useFetchJson<IOlympicData>(
"https://www.ag-grid.com/example-assets/olympic-winners.json",
);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact<IOlympicData>
rowData={data}
loading={loading}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
autoGroupColumnDef={autoGroupColumnDef}
rowSelection={rowSelection}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} import { useState, useEffect } from 'react';
/**
* Fetch example Json data
* Not recommended for production use!
*/
export const useFetchJson = <T,>(url:string, limit?: number) => {
const [data, setData] = useState<T[]>();
const [loading, setLoading] = useState(true);
useEffect(() => {
const fetchData = async () => {
setLoading(true);
// Note error handling is omitted here for brevity
const response = await fetch(url);
const json = await response.json();
const data = limit ? json.slice(0, limit) : json;
setData(data);
setLoading(false);
};
fetchData();
}, [url, limit]);
return { data, loading };
}; The example above demonstrates the following configuration:
const rowSelection = useMemo(() => {
return {
mode: 'multiRow',
groupSelects: 'descendants',
selectAll: 'all',
checkboxLocation: 'autoGroupColumn',
};
}, []);
<AgGridReact rowSelection={rowSelection} /> Custom Inner Renderer Copy Link
When using the group cell renderer, the agGroupCellRenderer component will inherit the grouped columns renderer and display this inside of the group cell, adjacent to any configured checkboxes, cell count, and the expand/collapse chevron control.
This inner renderer can be overridden with a Custom Cell Component by setting the innerRenderer and innerRendererParams properties on the cellRendererParams configuration.
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
ModuleRegistry,
RowGroupingDisplayType,
enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
import CustomMedalCellRenderer from "./customMedalCellRenderer.tsx";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
const modules = [ClientSideRowModelModule, RowGroupingModule];
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "total", rowGroup: true },
{ field: "country" },
{ field: "year" },
{ field: "athlete" },
{ field: "sport" },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
minWidth: 100,
};
}, []);
const autoGroupColumnDef = useMemo<AutoGroupColumnDef>(() => {
return {
headerName: "Gold Medals",
minWidth: 220,
cellRendererParams: {
suppressCount: true,
innerRenderer: CustomMedalCellRenderer,
},
};
}, []);
const { data, loading } = useFetchJson<IOlympicData>(
"https://www.ag-grid.com/example-assets/olympic-winners.json",
);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact<IOlympicData>
rowData={data}
loading={loading}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
autoGroupColumnDef={autoGroupColumnDef}
groupDisplayType={"singleColumn"}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
.imgSpan {
display: flex;
height: 40px;
width: 100%;
align-items: center;
}
.medalIcon {
display: block;
width: 15px;
height: auto;
max-height: 50%;
}
import React from 'react';
import { CustomCellRendererProps } from 'ag-grid-react';
export default (params: CustomCellRendererProps) => {
const priceArr: any[] = new Array(params.value ?? 0).fill('');
return (
<span className="imgSpan">
{priceArr.map((_, index) => (
<img key={index} src="https://www.ag-grid.com/example-assets/gold-star.png" className="medalIcon" />
))}
</span>
);
};
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} import { useState, useEffect } from 'react';
/**
* Fetch example Json data
* Not recommended for production use!
*/
export const useFetchJson = <T,>(url:string, limit?: number) => {
const [data, setData] = useState<T[]>();
const [loading, setLoading] = useState(true);
useEffect(() => {
const fetchData = async () => {
setLoading(true);
// Note error handling is omitted here for brevity
const response = await fetch(url);
const json = await response.json();
const data = limit ? json.slice(0, limit) : json;
setData(data);
setLoading(false);
};
fetchData();
}, [url, limit]);
return { data, loading };
}; The example above uses the following configuration to provide a custom inner renderer to the group column:
const autoGroupColumnDef = useMemo(() => {
return {
cellRendererParams: {
innerRenderer: CustomMedalCellRenderer,
},
};
}, []);
<AgGridReact autoGroupColumnDef={autoGroupColumnDef} /> Custom Cell Renderer Copy Link
The Group Cell Renderer can be entirely replaced with a Custom Cell Component by setting the cellRenderer property on the autoGroupColumnDef configuration.
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
AutoGroupColumnDef,
CellDoubleClickedEvent,
CellKeyDownEvent,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
ModuleRegistry,
enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
import CustomGroupCellRenderer from "./customGroupCellRenderer.tsx";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
const modules = [ClientSideRowModelModule, RowGroupingModule];
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{
field: "country",
rowGroup: true,
hide: true,
},
{
field: "year",
rowGroup: true,
hide: true,
},
{
field: "athlete",
},
{
field: "total",
aggFunc: "sum",
},
]);
const autoGroupColumnDef = useMemo<AutoGroupColumnDef>(() => {
return {
cellRenderer: CustomGroupCellRenderer,
};
}, []);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
minWidth: 120,
};
}, []);
const { data, loading } = useFetchJson<IOlympicData>(
"https://www.ag-grid.com/example-assets/small-olympic-winners.json",
);
const onCellDoubleClicked = useCallback(
(params: CellDoubleClickedEvent<IOlympicData, any>) => {
if (params.colDef.showRowGroup) {
params.node.setExpanded(!params.node.expanded);
}
},
[],
);
const onCellKeyDown = useCallback(
(params: CellKeyDownEvent<IOlympicData, any>) => {
if (!("colDef" in params)) {
return;
}
if (!(params.event instanceof KeyboardEvent)) {
return;
}
if (params.event.code !== "Enter") {
return;
}
if (params.colDef.showRowGroup) {
params.node.setExpanded(!params.node.expanded);
}
},
[],
);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact<IOlympicData>
rowData={data}
loading={loading}
columnDefs={columnDefs}
autoGroupColumnDef={autoGroupColumnDef}
defaultColDef={defaultColDef}
groupDefaultExpanded={1}
onCellDoubleClicked={onCellDoubleClicked}
onCellKeyDown={onCellKeyDown}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
import React, { useCallback, useEffect, useState } from 'react';
import { RowEvent } from 'ag-grid-community';
import { CustomCellRendererProps } from 'ag-grid-react';
export default (props: CustomCellRendererProps) => {
const { node, value } = props;
const [expanded, setExpanded] = useState(node.expanded);
useEffect(() => {
const expandListener = (event: RowEvent) => setExpanded(event.node.expanded);
node.addEventListener('expandedChanged', expandListener);
return () => {
node.removeEventListener('expandedChanged', expandListener);
};
}, []);
const onClick = useCallback(() => node.setExpanded(!node.expanded), [node]);
return (
<div
style={{
paddingLeft: `${node.level * 15}px`,
}}
>
{node.group && (
<div
style={{
cursor: 'pointer',
transform: expanded ? 'rotate(90deg)' : 'rotate(0deg)',
display: 'inline-block',
}}
onClick={onClick}
>
→
</div>
)}
{value}
</div>
);
};
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} import { useState, useEffect } from 'react';
/**
* Fetch example Json data
* Not recommended for production use!
*/
export const useFetchJson = <T,>(url:string, limit?: number) => {
const [data, setData] = useState<T[]>();
const [loading, setLoading] = useState(true);
useEffect(() => {
const fetchData = async () => {
setLoading(true);
// Note error handling is omitted here for brevity
const response = await fetch(url);
const json = await response.json();
const data = limit ? json.slice(0, limit) : json;
setData(data);
setLoading(false);
};
fetchData();
}, [url, limit]);
return { data, loading };
}; It is also possible to Determine Cell Renderers Dynamically.
Filtering Copy Link
The grid filters leaf rows by default, if all of a groups children are filtered out, the group is also hidden.
Inherit Row Grouped Columns Filters Copy Link
The single group column content changes depending on the columns which have row grouping enabled. The agGroupColumnFilter can be used to display the filters for the columns with row grouping enabled.
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
enableDevValidations,
} from "ag-grid-community";
import {
GroupFilterModule,
RowGroupingModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
const modules = [
NumberFilterModule,
ClientSideRowModelModule,
RowGroupingModule,
SetFilterModule,
GroupFilterModule,
];
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "country", rowGroup: true, hide: true, filter: true },
{ field: "year", rowGroup: true, hide: true, filter: true },
{ field: "athlete" },
{ field: "sport" },
{ field: "total" },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
minWidth: 100,
};
}, []);
const autoGroupColumnDef = useMemo<AutoGroupColumnDef>(() => {
return {
minWidth: 200,
filter: "agGroupColumnFilter",
floatingFilter: true,
};
}, []);
const onGridReady = useCallback((params: GridReadyEvent) => {
params.api.showColumnFilter("ag-Grid-AutoColumn");
}, []);
const { data, loading } = useFetchJson<IOlympicData>(
"https://www.ag-grid.com/example-assets/olympic-winners.json",
);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact<IOlympicData>
rowData={data}
loading={loading}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
autoGroupColumnDef={autoGroupColumnDef}
groupDefaultExpanded={1}
onGridReady={onGridReady}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} import { useState, useEffect } from 'react';
/**
* Fetch example Json data
* Not recommended for production use!
*/
export const useFetchJson = <T,>(url:string, limit?: number) => {
const [data, setData] = useState<T[]>();
const [loading, setLoading] = useState(true);
useEffect(() => {
const fetchData = async () => {
setLoading(true);
// Note error handling is omitted here for brevity
const response = await fetch(url);
const json = await response.json();
const data = limit ? json.slice(0, limit) : json;
setData(data);
setLoading(false);
};
fetchData();
}, [url, limit]);
return { data, loading };
}; The example above demonstrates the following configuration to enable the group column filter:
const autoGroupColumnDef = useMemo(() => {
return {
filter: 'agGroupColumnFilter',
floatingFilter: true,
};
}, []);
<AgGridReact autoGroupColumnDef={autoGroupColumnDef} />When accessing filter instances via API, access the filters on the columns with row grouping.
Tree Filter Copy Link
The agSetColumnFilter can be used to filter the group column in a Tree List, representing the hierarchy of the row groups.
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
KeyCreatorParams,
ModuleRegistry,
NumberFilterModule,
enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule, SetFilterModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
const modules = [
NumberFilterModule,
ClientSideRowModelModule,
RowGroupingModule,
SetFilterModule,
];
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "country", rowGroup: true, hide: true, filter: true },
{ field: "year", rowGroup: true, hide: true, filter: true },
{ field: "athlete" },
{ field: "sport" },
{ field: "total" },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
minWidth: 100,
};
}, []);
const autoGroupColumnDef = useMemo<AutoGroupColumnDef>(() => {
return {
minWidth: 200,
filter: true,
floatingFilter: true,
filterValueGetter: (params) => params.data?.athlete,
filterParams: {
treeList: true,
keyCreator: (params: KeyCreatorParams) =>
params.value ? params.value.join("#") : null,
},
};
}, []);
const onGridReady = useCallback((params: GridReadyEvent) => {
params.api.showColumnFilter("ag-Grid-AutoColumn");
}, []);
const { data, loading } = useFetchJson<IOlympicData>(
"https://www.ag-grid.com/example-assets/olympic-winners.json",
);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact<IOlympicData>
rowData={data}
loading={loading}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
autoGroupColumnDef={autoGroupColumnDef}
groupDefaultExpanded={1}
onGridReady={onGridReady}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} import { useState, useEffect } from 'react';
/**
* Fetch example Json data
* Not recommended for production use!
*/
export const useFetchJson = <T,>(url:string, limit?: number) => {
const [data, setData] = useState<T[]>();
const [loading, setLoading] = useState(true);
useEffect(() => {
const fetchData = async () => {
setLoading(true);
// Note error handling is omitted here for brevity
const response = await fetch(url);
const json = await response.json();
const data = limit ? json.slice(0, limit) : json;
setData(data);
setLoading(false);
};
fetchData();
}, [url, limit]);
return { data, loading };
}; The tree filter needs a value for each leaf row. In absence of a field or valueGetter on the group column, provide a filterValueGetter to the group column definition.
The example above demonstrates the following configuration to enable the tree set filter:
const autoGroupColumnDef = useMemo(() => {
return {
filter: 'agSetColumnFilter',
filterValueGetter: (params) => params.data.athlete,
filterParams: {
treeList: true,
keyCreator: (params) => (params.value ? params.value.join('#') : null),
},
};
}, []);
<AgGridReact autoGroupColumnDef={autoGroupColumnDef} />Refer to the Tree List Filter documentation for further configuration options.
Text Filtering Copy Link
Providing a filter value getter to the group column allows for a simple string search of any group level.
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
ModuleRegistry,
NumberFilterModule,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
const modules = [
NumberFilterModule,
ClientSideRowModelModule,
RowGroupingModule,
TextFilterModule,
];
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "country", rowGroup: true, hide: true, filter: true },
{ field: "year", rowGroup: true, hide: true, filter: true },
{ field: "athlete" },
{ field: "sport" },
{ field: "total" },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
minWidth: 100,
};
}, []);
const autoGroupColumnDef = useMemo<AutoGroupColumnDef>(() => {
return {
minWidth: 200,
filter: "agTextColumnFilter",
floatingFilter: true,
filterValueGetter: (params) => params.node?.parent?.getRoute(),
};
}, []);
const { data, loading } = useFetchJson<IOlympicData>(
"https://www.ag-grid.com/example-assets/olympic-winners.json",
);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact<IOlympicData>
rowData={data}
loading={loading}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
autoGroupColumnDef={autoGroupColumnDef}
groupDefaultExpanded={1}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} import { useState, useEffect } from 'react';
/**
* Fetch example Json data
* Not recommended for production use!
*/
export const useFetchJson = <T,>(url:string, limit?: number) => {
const [data, setData] = useState<T[]>();
const [loading, setLoading] = useState(true);
useEffect(() => {
const fetchData = async () => {
setLoading(true);
// Note error handling is omitted here for brevity
const response = await fetch(url);
const json = await response.json();
const data = limit ? json.slice(0, limit) : json;
setData(data);
setLoading(false);
};
fetchData();
}, [url, limit]);
return { data, loading };
}; The example above demonstrates using a filter value getter which returns an array of ancestor row keys. This enables searching for any group value containing the filter text:
const autoGroupColumnDef = useMemo(() => {
return {
filter: 'agTextColumnFilter',
filterValueGetter: (params) => params.node.parent.getRoute(),
};
}, []);
<AgGridReact autoGroupColumnDef={autoGroupColumnDef} />